%  Alg1.m
function[x,J,fx,Dinv,msg,alg,j] = Alg1(c,C,n,tol,x,J,Dinv)
%  Alg1 implements QP Algorithm 1 to solve an
%  unconstrained quadratic minimization problem.

%  Initialization
alg = 'Algorithm 1';
fx = c'*x + x'*C*x/2.;
g = c + C *x;
for j = 0:n
    %  Step 1: Computation of Search Direction s_j
    %  nzero = # components of J having value 0
    nzerolist = find(J == 0);
    nzero = length(nzerolist);
    if nzero == 0
        msg = 'Optimal solution obtained';
    return
    end
    if nzero >= 1
        dotprod = abs(g'* Dinv(:,nzerolist) );
        big = max(dotprod);
        k = nzerolist(find(big==dotprod,1));
        gjckj = g'* Dinv(:,k); 
        % get the correct sign for gjckj
        if gjckj > 0.;
            s = Dinv(:,k);
        elseif gjckj <= 0.
            s = - Dinv(:,k);
        end
        if abs(big) < tol
            msg = 'Optimal solution obtained';
        return
        end
    end        
    
    %  Step 2 of Algorithm 1
    %  optimal step size (sigtil)
    
    stCs = s'*C*s;
    if abs(stCs) < tol
        msg = 'Unbounded from below';
        return
    end
    sigtil = big/stCs;
    sigma = sigtil;

    %  Step 3 of Algorithm 1
    
    x = x - sigma*s;
    g = c + C*x;
    fx = c'*x +x'*C*x/2.;
    d =  sqrt(stCs)*C*s;
    [Dinvnew] = Phi1(Dinv,d,k,J,n);
    Dinv = Dinvnew;
    J(k) = -1;
end

end


