    %   Psi3.m
    function [ H1inv ] = Psi3 ( H0inv,d,p,q )
    
    %  Sherman-Morrison update for (A + uv')^{-1} where
    %  u = [e_q, d], v = [d, e_q], e_q = q-th unit vector
    %  H0inv, H1inv are (p,p)
    tol = 1.e-6;
    eq = zeros(p,1);
    eq(q) = 1.;
    u = [ eq d ];
    v = [ d eq ];
    sm = eye(2) + v'*H0inv*u; 
    detsm = det(sm);
    H1inv = H0inv - H0inv*u*inv(eye(2) + v'*H0inv*u)*v'*H0inv;
    return
    end
    
    
   
    