%       Step1.m
%  This is Step 1 for each of Algorithms 3, 4 and 10.
%  It is coded as a function to avoid repetition.
function[next,k,s,msg,dual,big] = Step1(J,next,g,Dinv,n,m,r,tol)
msg = ' ';  dual = (1.);  s = [1.]; k = 0; big = -100.;
%  Step 1: Computation of Search Direction s_j
        %  nzero = # components of J having value 0
nzerolist = find(J == 0);
nzero = length(nzerolist);
if nzero >= 1;
    next = 'Step1p1';
else
    next = 'Step1p2';
end    
if strcmp(next,'Step1p1')
    % Step 1.1
    dotprod = abs(g'* Dinv(:,nzerolist) );
    big = max(dotprod);
    k = nzerolist(find(big==dotprod,1));
    gjckj = g'* Dinv(:,k); 
    % get the correct sign for gjckj
    if gjckj > 0.;
        s = Dinv(:,k);
    elseif gjckj <= 0.
        s = - Dinv(:,k);
        end
    next = 'Step2';
        
elseif strcmp(next,'Step1p2')
    % Step 1.2
    n12mlist = find(J >= 1 & J <= m);
    n12m = length(n12mlist);
    %  n12m = # components of J having value between 
    %           1 and m
        
        
    if n12m == 0;
        % We have an optimal solution
        msg = 'Optimal solution obtained';
        [dual] = GetDual(Dinv,J,g,n,m,r);
        return
    end
        
    if n12m >= 1
        dotprod = g'* Dinv(:,n12mlist);
        big = max(dotprod);
        k = n12mlist(find(big==dotprod,1));
    end
    
    if big <= tol
        %  Opimal Solution Obtained
        msg = 'Optimal solution obtained';
        [dual] = GetDual(Dinv,J,g,n,m,r);
        return
    else
        s = Dinv(:,k);
    end
    next = 'Step2';
end     % end of Step1p2
