%       Step2.m
%  This is Step 2 for each of Algorithms 3, 4 and 10.
%  It is coded as a function to avoid repetition.
function[next,sigma,sigtil,sighat,ell,stCs,msg] = ...
                     Step2(J,m,A,b,C,s,tol,big,x)
msg = ' ';  next = 'Step3'; sigma = 1.;
% opimal step size (sigtil)
stCs = s'*C*s;
if stCs <- 1.e-6
    sigtil = Inf;
else
    sigtil = big/stCs;
end

% maximum feasible stepsize (sighat)
sighat = Inf;
ell = 0;
inactive = setdiff(1:m,J);
for i=1:length(inactive)
    As = A(inactive(i),:)*s;
    if As < -tol
        test = (A(inactive(i),:)*x - b(inactive(i)))/As;
        if test < sighat
            sighat = test;
            ell = inactive(i);
        end
    end
end
if sighat == Inf && sigtil == Inf
    msg = 'Unbounded from below';
    return
end
sigma = min(sigtil,sighat);
next = 'Step3';










